'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _Renderer = require('./../Renderer');

var _styledComponents = require('styled-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ClientRenderer = function () {
  function ClientRenderer(props) {
    _classCallCheck(this, ClientRenderer);

    this.projectPath = props.projectPath;
    this.state = props.state;
    this.req = props.req;
    this.targetView = props.targetView;
  }

  _createClass(ClientRenderer, [{
    key: 'render',
    value: function render() {
      var _this = this;

      var req = this.req;
      var preloadedState = this.preloadedState;

      return new Promise(function (fulfill, reject) {

        var compPath = _this.projectPath + '/Client/index.js';
        // turn off for prod env
        //      if(typeof(require.cache[compPath])!='undefined') {
        //        delete require.cache[compPath];
        //      }

        try {
          var preloadedState = _this.state;
          var injectedPreloadedState = JSON.stringify(preloadedState);

          var sourceComponent = require(compPath).default;
          var Component = _react2.default.createFactory(sourceComponent);
          var ssr = {
            location: req.url,
            context: {},
            preloadedState: preloadedState
          };

          var initatedComponent = _react2.default.createElement(Component, { ssr: ssr });

          var sheet = new _styledComponents.ServerStyleSheet();

          var htmlStyle = (0, _server.renderToString)(sheet.collectStyles(initatedComponent));
          var styleTags = sheet.getStyleTags();

          var renderedClient = (0, _server.renderToString)(initatedComponent);
        } catch (e) {
          var message = e.message || '';
          var stack = e.stack || '';
          var renderedClient = 'Error rendering ' + compPath + ':<br/><br/><div style=\'color:#ff0000\'>' + message + '<br/><br/>' + stack + '</div>';
        }
        var CLIENT_INJECTOR = '<script>window.__PRELOADED_STATE__=' + injectedPreloadedState + '</script><div id=\'client-wrapper\'>' + renderedClient + '</div><script src="/public/clientjs/vendor.js"></script><script src="/public/clientjs/main.js"></script>';

        var viewRenderer = new _Renderer.ViewRenderer({
          filePath: _this.projectPath + '/Views/' + _this.targetView,
          data: {
            CLIENT: CLIENT_INJECTOR,
            STYLED_COMPONENTS_STYLE_TAG: styleTags
          }
        });
        viewRenderer.render().then(function (renderedHtml) {
          fulfill(renderedHtml);
        }).catch(function (e) {
          console.log(e);
          reject(e);
        });
      });
    }
  }]);

  return ClientRenderer;
}();

exports.default = ClientRenderer;