import React from 'react';
import { renderToString } from 'react-dom/server'
import { ViewRenderer } from './../Renderer';
import { ServerStyleSheet, StyleSheetManager } from 'styled-components';
  


export default class ClientRenderer {
  
  constructor(props) {
    this.projectPath = props.projectPath;
    this.state = props.state;
    this.req = props.req;
    this.targetView = props.targetView;
    
    
  }

  render() {

    let req = this.req;
    let preloadedState = this.preloadedState;
    
    return new Promise((fulfill, reject) => {
      
      let compPath = `${this.projectPath}/Client/index.js`;
      // turn off for prod env
//      if(typeof(require.cache[compPath])!='undefined') {
//        delete require.cache[compPath];
//      }

      try {
        var preloadedState = this.state;
        var injectedPreloadedState = JSON.stringify(preloadedState);
        
        var sourceComponent = require(compPath).default;
        var Component = (React.createFactory(sourceComponent));
        var ssr = {
          location: req.url,
          context: { },
          preloadedState: preloadedState
        }
        
        var initatedComponent = <Component ssr={ssr} />;
        

        const sheet = new ServerStyleSheet()

        const htmlStyle = renderToString(sheet.collectStyles(initatedComponent))
        var styleTags = sheet.getStyleTags()

 
        var renderedClient = renderToString(initatedComponent);
      
      } catch(e) {
          var message = e.message || '';
          var stack = e.stack || ''
          var renderedClient = `Error rendering ${compPath}:<br/><br/><div style='color:#ff0000'>${message}<br/><br/>${stack}</div>`;
        
        
      }
      let CLIENT_INJECTOR = `<script>window.__PRELOADED_STATE__=${injectedPreloadedState}</script><div id='client-wrapper'>${renderedClient}</div><script src="/public/clientjs/vendor.js"></script><script src="/public/clientjs/main.js"></script>`;
      
      var viewRenderer = new ViewRenderer({
        filePath: `${this.projectPath}/Views/${this.targetView}`,
        data: {
          CLIENT: CLIENT_INJECTOR,
          STYLED_COMPONENTS_STYLE_TAG: styleTags
        }
      });
      viewRenderer.render().then(renderedHtml => {
        fulfill(renderedHtml);
      }).catch(e => {
        console.log(e);
        reject(e);
      })
    });

  }
}